MODULE GraphTest;

IMPORT StdLog := Out, G := GraphLib, SYSTEM, SDL := GraphSdl;

VAR
  screen: G.Bitmap;
  jj: INTEGER;

PROCEDURE Draw;
VAR i, x, y, color: INTEGER;
  A: ARRAY [untagged] 16 OF SHORTCHAR;
BEGIN
  color := G.MakeCol(220, 40, 10);
  G.RectFill(screen, 10, 10, 80, 60, color);
  color := G.MakeCol(255, 255, 200);
  jj := (jj * 31 + 17) MOD MAX(INTEGER);
  FOR i := jj TO jj + 5 DO
    x := (i * 521 + 61) MOD screen.w;
    y := (i * 13 + 11) MOD screen.h;
    G.PutPixel(screen, x, y, color)
  END;
  G.Flip;
  (*G.Rest(40)*)
END Draw;

PROCEDURE Run;
VAR quit: BOOLEAN;
  key, code: INTEGER;
BEGIN
  G.ClearScreenToColor(G.MakeCol(0, 40, 60));
  G.RectFill(screen, 100, 5, 10, 60, G.MakeCol(255, 0, 0));
  jj := 0;
  quit := FALSE;
  REPEAT
    IF G.KeyPressed() THEN
      key := G.ReadKey();
      code := G.GetScancode(key);
      IF code = G.keyEsc THEN quit := TRUE END
    END;
    Draw
  UNTIL quit OR G.closing
END Run;

PROCEDURE Do*;
BEGIN
  G.Settings(320, 200, {G.fullscreen, G.spread, G.initMouse});
  screen := G.Init();
  IF screen = NIL THEN
    StdLog.String('Graph Init failed.'); StdLog.Ln
  ELSE
    Run;
    G.Close
  END
END Do;

BEGIN
  Do
END GraphTest.

